;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_INITIALISIERUNG:
	cbi (DCF_DDR) ,(DCF_PIN_NR) ; auf EINGANG
	cbi (DCF_PORT),(DCF_PIN_NR) ; PULL UP aus, wichtig, denn manche DCF-Module sehr hochohmig !
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; Abtastung erfolgt 100 mal pro Sekunde										
; HF-Trgersigal auswerten													
; HF-Austastung 100ms=LOW													
; HF-Austastung 200ms=HIGH													
; keine Austastung >1s = Minutenanfang										
; OUT: temp1																
DCF_PIN_ABFRAGEN_TEMP1:
	; PIN abfragen		
	sbic DCF_PIN,DCF_PIN_NR	; springe, wenn...
	rjmp DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_ON
	rjmp DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_OFF
DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_OFF:
	clr temp1	; temp1=0=LED off	
	rjmp DCF_PIN_ABFRAGEN_TEMP1_FERTIG
DCF_PIN_ABFRAGEN_77kHz_AUSTASTUNG_ON:
	ldi temp1,1	; temp1=1=LED on	
DCF_PIN_ABFRAGEN_TEMP1_FERTIG:
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_PIN_PHASE_TEMP1:
	; ZEIGER + 1		
	LDS temp,(adr_DCF_SAMPLES_ZEIGER)
	inc temp
	STS(adr_DCF_SAMPLES_ZEIGER),temp
	cpi temp,100
	brlo DCF_PIN_PHASE_TEMP1_w
	STS(adr_DCF_SAMPLES_ZEIGER),NULL
DCF_PIN_PHASE_TEMP1_w:
;---------------------------------------------------------------------------
	; momentaner Impuls=1 ?		
	tst temp1
	breq DCF_PIN_SPERRE_TEMP1_ww
	; OLD <> momentaner Impuls ?
	LDS temp,(adr_DCF_IMPULS_OLD)
	cp temp,temp1
	breq DCF_PIN_SPERRE_TEMP1_ww
	LDS temp,(adr_DCF_SAMPLES_ZEIGER)	
	; PHASE speichern			
	STS(adr_DCF_IMPULS_PHASE),temp
	; Phase schieben			
	cpi temp, 2+1
	brlo DCF_PIN_SPERRE_TEMP1_ww
	; welche Richtung ?			
	cpi temp,50
	brlo DCF_PIN_SPERRE_TEMP1_MINUS
DCF_PIN_SPERRE_TEMP1_PLUS:
	LDS temp,(adr_DCF_SAMPLES_ZEIGER)
	inc temp
	STS(adr_DCF_SAMPLES_ZEIGER),temp
	cpi temp,100
	brlo DCF_PIN_SPERRE_TEMP1_ww
	STS(adr_DCF_SAMPLES_ZEIGER),NULL
	rjmp DCF_PIN_SPERRE_TEMP1_ww
DCF_PIN_SPERRE_TEMP1_MINUS:
	LDS temp,(adr_DCF_SAMPLES_ZEIGER)
	dec temp
	STS(adr_DCF_SAMPLES_ZEIGER),temp
DCF_PIN_SPERRE_TEMP1_ww:
	; OLD speichern				
	STS(adr_DCF_IMPULS_OLD),temp1
DCF_PIN_SPERRE_TEMP1_FERTIG:
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; LED-GELB-AUSWERTUNG														
; INP/OUT: temp1															
DCF_LED_TEMP1:
	tst temp1	
	breq DCF_LED_TEMP1_OFF
	rjmp DCF_LED_TEMP1_ON
DCF_LED_TEMP1_ON:
	; LED blinkt, wenn DCF Signal nicht gltig	
	LDS temp,(adr_DCF_GUELTIG)
	tst temp
	brne DCF_LED_TEMP1_OFF
	cbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	 ; GELB-AN	
	rjmp DCF_LED_TEMP_FERTIG
DCF_LED_TEMP1_OFF:
	sbi (LED_DCF_GELB_PORT),(LED_DCF_GELB_PIN_NR)	 ; GELB-AUS	
DCF_LED_TEMP_FERTIG:
;######################################################################## 	
;########################################################################	
;######################################################################## 	
; LOW=100ms(10) HIGH=200ms(20)												
;  10ms=00=Initialisierung													
;  20ms=01=nix																
;  30ms=02=SAMPLES-A														
;  40ms=03=SAMPLES-A														
;  50ms=04=SAMPLES-A														
;  60ms=05=SAMPLES-A														
;  70ms=06=SAMPLES-A														
;  80ms=07=SAMPLES-A														
;  90ms=08=nix																
; 100ms=09=nix																
; 110ms=10=nix																
; 120ms=11=nix																
; 130ms=12=SAMPLES-B														
; 140ms=13=SAMPLES-B														
; 150ms=14=SAMPLES-B														
; 160ms=15=SAMPLES-B														
; 170ms=16=SAMPLES-B														
; 180ms=17=SAMPLES-B														
; 190ms=18=nix																
; 200ms=19=nix																
;																			
;ca900ms=write																
DCF_SAMPLES_A_B_TEMP1:
	LDS temp,(adr_DCF_SAMPLES_ZEIGER)
	cpi temp,0							; 0			
	breq DCF_SAMPLES_A_B_INITIALISIERUNG

	cpi temp,1							; 1			
	breq DCF_SAMPLES_A_B_DUMMY

	cpi temp,7+1						; 2...7		
	brlo DCF_SAMPLES_A

	cpi temp,11+1						; 8...11	
	brlo DCF_SAMPLES_A_B_DUMMY


	cpi temp,17+1						; 12...17	
	brlo DCF_SAMPLES_B
	cpi temp,95							; write		
	breq DCF_SAMPLES_WRITE

DCF_SAMPLES_A_B_DUMMY:
	ret
DCF_SAMPLES_A_B_INITIALISIERUNG:
	STS(adr_DCF_SAMPLES_A),NULL
	STS(adr_DCF_SAMPLES_B),NULL
	ret
;---------------------------------------------------------------------------
DCF_SAMPLES_A:
	tst temp1
	brne DCF_SAMPLES_Aw
	ret
DCF_SAMPLES_Aw:
	STS(adr_DCF_SAMPLES_A),EINS
	ret
;---------------------------------------------------------------------------
DCF_SAMPLES_B:
	tst temp1
	brne DCF_SAMPLES_Bw
	ret
DCF_SAMPLES_Bw:
	STS(adr_DCF_SAMPLES_B),EINS
	ret
;---------------------------------------------------------------------------
DCF_SAMPLES_WRITE:
	; MINUTENANFANG			
	LDS temp,(adr_DCF_SAMPLES_A)
	tst temp
	brne DCF_SAMPLES_WRITE_RUN
	; MINUTENANFANG erkannt	
	rjmp DCF_MINUTENSTART_ZEIT_BERECHNUNG
DCF_SAMPLES_WRITE_RUN:
	LDS temp,(adr_DCF_SAMPLES_B)
	STS(adr_DCF_BIT),temp
	rjmp DCF_DATENFELD_SCHREIBEN
;######################################################################## 	
;########################################################################	
;######################################################################## 	
DCF_DATENFELD_SCHREIBEN:
	; Z sichern					
	push ZL
	push ZH
	; Z-ZEIGER initialisieren	
	LDI ZL, low(adr_DCF_BEREICH)
	LDI ZH,high(adr_DCF_BEREICH)
	; DCF-ZEIGER laden			
	LDS temp, (adr_DCF_ZEIGER)
	; Fehlerprng				
	cpi temp,59
	brlo DCF_DATENFELD_SCHREIBEN_OK
;---------------------------------------------------------------------------
	; ERROR						
	ldi temp,(ERROR_DCF_DATENFELD)
	STS(adr_DCF_ERROR_CODE),temp
	; DCF GUELTIG auf NULL setzen	
	STS(adr_DCF_GUELTIG),NULL	
	; DCF-ZEIGER NULL				
	STS(adr_DCF_ZEIGER),NULL
	; LED							
	sbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR); DCF-GRUEN	
	; Z wiederherstellen		
	pop ZH
	pop ZL
	ret
;---------------------------------------------------------------------------
DCF_DATENFELD_SCHREIBEN_OK:
	; addieren					
	add ZL,temp
	adc ZH,NULL
	; DCF ZEIGER +1				
	inc temp
	STS (adr_DCF_ZEIGER),temp
	; DCF-BIT in's Datenfeld schreiben	
	LDS temp,(adr_DCF_BIT)
	ST Z,temp
	; Z wiederherstellen		
	pop ZH
	pop ZL
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
;Bit(s) Anzahl 		Bedeutung 												
; 0 	1 bit	Start einer neuen Minute (ist immer "0") 					
;16 				"1": Am Ende dieser Stunde wird MEZ/MESZ umgestellt. 	
;17 				"0": MEZ, "1": MESZ 									
;18 				"0": MESZ, "1": MEZ 									
;19 				"1": Am Ende dieser Stunde wird eine Schaltsekunde eingefgt. 
;20 		1 bit 	Beginn der Zeitinformation (ist immer "1") 				
;21-27 		7 bit 	Minute (Werte der einzelnen Bits: 1,2,4,8,10,20,40) 	
;28 		1 bit 	Paritt Minute 											
;29-34 		6 bit 	Stunde (1, 2, 4, 8, 10, 20) 							
;35 		1 bit 	Paritt Stunde 											
;36-41 		6 bit 	Monatstag (1, 2, 4, 8, 10, 20) 							
;42-44 		3 bit 	Wochentag (1, 2, 4) 									
;45-49 		5 bit 	Monat (1, 2, 4, 8, 10) 									
;50-57 		8 bit 	Jahr (zweistellig; 1, 2, 4, 8, 10, 20, 40, 80) 			
;58 		1 bit 	Paritt Datum 											
DCF_MINUTENSTART_ZEIT_BERECHNUNG:
	; DCF GUELTIG auf NULL setzen		
	STS(adr_DCF_GUELTIG),NULL
	sbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR); DCF-GRUEN	
	; DCF-Zeiger muss auf 59 stehen		
	LDS temp, (adr_DCF_ZEIGER)
	STS(adr_DCF_ZEIGER),NULL	; DCF-ZEIGER NULL	
	cpi temp,59
	breq DCF_ZEIT_00
	; ERROR								
	ldi temp,(ERROR_DCF_MINUTENIMPULS)
	STS(adr_DCF_ERROR_CODE),temp
	ret
;0 			1 bit	Start einer neuen Minute (ist immer "0") 				
DCF_ZEIT_00:
	LDS temp,(adr_DCF_BEREICH+0)			; aus SRAM laden	
 	tst temp 
	breq DCF_ZEIT_00_OK
	; ERROR						
	ldi temp,(ERROR_DCF_NO_ANFANGSBIT)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_00_OK:
;17 SOMMERZEIT aktiv				"0": MEZ, "1": MESZ 									
	LDS temp,(adr_DCF_BEREICH+17)			; aus SRAM laden	
	STS (adr_DCF_SOMMERZEIT),temp			; im SRAM ablegen	
;18 WINTERZEIT aktiv				"1": MEZ, "0": MESZ 							
	LDS temp1,(adr_DCF_BEREICH+18)			; aus SRAM laden	
	; MEZ<>MESZ					
	add temp,temp1
	cpi temp,1
	breq DCF_ZEIT_18_OK
	; ERROR						
	ldi temp,(ERROR_DCF_MESZ)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_18_OK:
;20 		1 bit 	Beginn der Zeitinformation (ist immer "1") 	
DCF_ZEIT_20:
	LDS temp,(adr_DCF_BEREICH+20)			; aus SRAM laden	
 	tst temp 
	brne DCF_ZEIT_21
	; ERROR-CODE			
	ldi temp,(ERROR_DCF_NO_ZEITINFORMATIONSBIT)
	STS(adr_DCF_ERROR_CODE),temp
	ret
;21-27 		7 bit 	Minute (Werte der einzelnen Bits: 1,2,4,8,10,20,40) 	
DCF_ZEIT_21:
	clr temp1
	LDS temp,(adr_DCF_BEREICH+21)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_22
	subi temp1,-1 
DCF_ZEIT_22:
	LDS temp,(adr_DCF_BEREICH+22)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_23
	subi temp1,-2 
DCF_ZEIT_23:
	LDS temp,(adr_DCF_BEREICH+23)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_24
	subi temp1,-4 
DCF_ZEIT_24:
	LDS temp,(adr_DCF_BEREICH+24)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_25
	subi temp1,-8 
DCF_ZEIT_25:
	LDS temp,(adr_DCF_BEREICH+25)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_26
	subi temp1,-10 
DCF_ZEIT_26:
	LDS temp,(adr_DCF_BEREICH+26)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_27
	subi temp1,-20 
DCF_ZEIT_27:
	LDS temp,(adr_DCF_BEREICH+27)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_27w
	subi temp1,-40 
DCF_ZEIT_27w:
	; MINUTENWERT bernehmen	
	STS(adr_DCF_mm),temp1
;28 		1 bit 	Paritt Minute 											
DCF_ZEIT_28:
	; Paritt berechnen			
	clr temp1
	LDS temp,(adr_DCF_BEREICH+21) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+22) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+23) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+24) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+25) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+26) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+27) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	; BIT-MUSTER (bei gerader Anzahl von HIGH = NULL)
	andi temp1,0b00000001
	; Paritt laden				
	LDS temp,(adr_DCF_BEREICH+28) 			; aus SRAM laden	
	; Paritt vergleichen		
	cp temp1,temp
	breq DCF_ZEIT_28_OK
	; ERROR						
	ldi temp,(ERROR_DCF_PARITAET_MINUTE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_28_OK:
;29-34 		6 bit 	Stunde (1, 2, 4, 8, 10, 20) 							
DCF_ZEIT_29:
	clr temp1
	LDS temp,(adr_DCF_BEREICH+29)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_30
	subi temp1,-1 
DCF_ZEIT_30:
	LDS temp,(adr_DCF_BEREICH+30)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_31
	subi temp1,-2 
DCF_ZEIT_31:
	LDS temp,(adr_DCF_BEREICH+31)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_32
	subi temp1,-4 
DCF_ZEIT_32:
	LDS temp,(adr_DCF_BEREICH+32)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_33
	subi temp1,-8 
DCF_ZEIT_33:
	LDS temp,(adr_DCF_BEREICH+33)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_34
	subi temp1,-10 
DCF_ZEIT_34:
	LDS temp,(adr_DCF_BEREICH+34)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_34w
	subi temp1,-20 
DCF_ZEIT_34w:
	; STUNDENWERT bernehmen	
	STS(adr_DCF_hh),temp1
;35 		1 bit 	Paritt Stunde 											
DCF_ZEIT_35:
	; Paritt berechnen		
	clr temp1
	LDS temp,(adr_DCF_BEREICH+29) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+30) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+31) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+32) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+33) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+34) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	; BIT-MUSTER (bei gerader Anzahl von HIGH = NULL)
	andi temp1,0b00000001
	; Paritt laden				
	LDS temp,(adr_DCF_BEREICH+35) 			; aus SRAM laden	
	; Paritt vergleichen		
	cp temp1,temp
	breq DCF_ZEIT_35_OK
	; ERROR-CODE				
	ldi temp,(ERROR_DCF_PARITAET_STUNDE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_35_OK:
;36-41 		6 bit 	Monatstag (1, 2, 4, 8, 10, 20) 							
DCF_ZEIT_36:
	clr temp1
	LDS temp,(adr_DCF_BEREICH+36)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_37
	subi temp1,-1 
DCF_ZEIT_37:
	LDS temp,(adr_DCF_BEREICH+37)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_38
	subi temp1,-2
DCF_ZEIT_38:
	LDS temp,(adr_DCF_BEREICH+38)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_39
	subi temp1,-4 
DCF_ZEIT_39:
	LDS temp,(adr_DCF_BEREICH+39)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_40
	subi temp1,-8 
DCF_ZEIT_40:
	LDS temp,(adr_DCF_BEREICH+40)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_41
	subi temp1,-10 
DCF_ZEIT_41:
	LDS temp,(adr_DCF_BEREICH+41)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_41w
	subi temp1,-20 
DCF_ZEIT_41w:
	; TAG bernehmen	
	STS(adr_DCF_TAG),temp1
;42-44 		3 bit 	Wochentag (1, 2, 4) 									
DCF_ZEIT_42:
	clr temp1
	LDS temp,(adr_DCF_BEREICH+42)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_43
	subi temp1,-1 
DCF_ZEIT_43:
	LDS temp,(adr_DCF_BEREICH+43)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_44
	subi temp1,-2 
DCF_ZEIT_44:
	LDS temp,(adr_DCF_BEREICH+44)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_44w
	subi temp1,-4 
DCF_ZEIT_44w:
	; WOCHENTAG bernehmen	
	STS(adr_DCF_WOCHENTAG),temp1
;45-49 		5 bit 	Monat (1, 2, 4, 8, 10) 									
DCF_ZEIT_45:
	clr temp1
	LDS temp,(adr_DCF_BEREICH+45)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_46
	subi temp1,-1 
DCF_ZEIT_46:
	LDS temp,(adr_DCF_BEREICH+46)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_47
	subi temp1,-2 
DCF_ZEIT_47:
	LDS temp,(adr_DCF_BEREICH+47)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_48
	subi temp1,-4 
DCF_ZEIT_48:
	LDS temp,(adr_DCF_BEREICH+48)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_49
	subi temp1,-8 
DCF_ZEIT_49:
	LDS temp,(adr_DCF_BEREICH+49)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_49w
	subi temp1,-10 
DCF_ZEIT_49w:
	; MONAT bernehmen	
	STS(adr_DCF_MONAT),temp1
;50-57 		8 bit 	Jahr (zweistellig; 1, 2, 4, 8, 10, 20, 40, 80) 			
DCF_ZEIT_50:
	clr temp1
	LDS temp,(adr_DCF_BEREICH+50)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_51
	subi temp1,-1 
DCF_ZEIT_51:
	LDS temp,(adr_DCF_BEREICH+51)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_52
	subi temp1,-2 
DCF_ZEIT_52:
	LDS temp,(adr_DCF_BEREICH+52)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_53
	subi temp1,-4 
DCF_ZEIT_53:
	LDS temp,(adr_DCF_BEREICH+53)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_54
	subi temp1,-8 
DCF_ZEIT_54:
	LDS temp,(adr_DCF_BEREICH+54)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_55
	subi temp1,-10 
DCF_ZEIT_55:
	LDS temp,(adr_DCF_BEREICH+55)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_56
	subi temp1,-20 
DCF_ZEIT_56:
	LDS temp,(adr_DCF_BEREICH+56)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_57
	subi temp1,-40 
DCF_ZEIT_57:
	LDS temp,(adr_DCF_BEREICH+57)			; aus SRAM laden	
	tst temp
	breq DCF_ZEIT_57w
	subi temp1,-80 
DCF_ZEIT_57w:
	; JAHR bernehmen	
	STS(adr_DCF_JAHR),temp1
;58 		1 bit 	Paritt Datum 											
DCF_ZEIT_58:
	; Paritt berechnen		
	clr temp1
	; TAG	
	LDS temp,(adr_DCF_BEREICH+36) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+37) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+38) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+39) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+40) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+41) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	; WOCHENTAG	
	LDS temp,(adr_DCF_BEREICH+42) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+43) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+44) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	; MONAT		
	LDS temp,(adr_DCF_BEREICH+45) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+46) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+47) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+48) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	LDS temp,(adr_DCF_BEREICH+49) 			; aus SRAM laden	
	add temp1,temp							; addieren	
	; JAHR		
	LDS temp,(adr_DCF_BEREICH+50) 			; aus SRAM laden	
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+51) 			; aus SRAM laden	
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+52) 			; aus SRAM laden	
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+53) 			; aus SRAM laden	
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+54) 			; aus SRAM laden	
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+55) 			; aus SRAM laden	
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+56) 			; aus SRAM laden	
	add temp1,temp
	LDS temp,(adr_DCF_BEREICH+57) 			; aus SRAM laden	
	add temp1,temp

	; BIT-MUSTER (bei gerader Anzahl von HIGH = NULL)
	andi temp1,0b00000001
	; Paritt laden				
	LDS temp,(adr_DCF_BEREICH+58) 			; aus SRAM laden	
	; Paritt vergleichen		
	cp temp1,temp
	breq DCF_ZEIT_58_OK
	; ERROR						
	ldi temp,(ERROR_DCF_PARITAET_DATUM)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_58_OK:
; --------------------------------------------------------------------------
	; Fehlerprfung STUNDE 0...23	
	LDS temp,(adr_DCF_hh)
	cpi temp,(23+1)
	brlo DCF_ZEIT_STUNDE_OK
	; ERROR						
	ldi temp,(ERROR_DCF_STUNDE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_STUNDE_OK:
; --------------------------------------------------------------------------
	; Fehlerprfung MINUTE 0...59
	LDS temp,(adr_DCF_mm)
	cpi temp,(59+1)
	brlo DCF_ZEIT_MINUTE_OK
	; ERROR						
	ldi temp,(ERROR_DCF_MINUTE)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_MINUTE_OK:
; --------------------------------------------------------------------------
	; Fehlerprfung WOCHENTAG 1=MO 1...7	
	LDS temp,(adr_DCF_WOCHENTAG)
	tst temp
	breq DCF_ZEIT_WOCHENTAG_ERROR
	cpi temp,(7+1)
	brlo DCF_ZEIT_WOCHENTAG_OK
	; ERROR						
DCF_ZEIT_WOCHENTAG_ERROR:
	ldi temp,(ERROR_DCF_WOCHENTAG)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_WOCHENTAG_OK:
; --------------------------------------------------------------------------
	; Fehlerprfung TAG	1...31	
	LDS temp,(adr_DCF_TAG)
	tst temp
	breq DCF_ZEIT_TAG_ERROR
	cpi temp,(31+1)
	brlo DCF_ZEIT_TAG_OK
	; ERROR						
DCF_ZEIT_TAG_ERROR:
	ldi temp,(ERROR_DCF_TAG)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_TAG_OK:
; --------------------------------------------------------------------------
	; Fehlerprfung MONAT 1...12	
	LDS temp,(adr_DCF_MONAT)
	tst temp
	breq DCF_ZEIT_MONAT_ERROR
	cpi temp,(12+1)
	brlo DCF_ZEIT_MONAT_OK
	; ERROR						
DCF_ZEIT_MONAT_ERROR:
	ldi temp,(ERROR_DCF_MONAT)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_MONAT_OK:
; --------------------------------------------------------------------------
	; Fehlerprfung Jahr 12...40
	LDS temp,(adr_DCF_JAHR)
	cpi temp,(40+1)		; <=40
	brlo DCF_ZEIT_JAHR_OK
	cpi temp,(12)		; >=12
	brsh DCF_ZEIT_JAHR_OK
	; ERROR						
	ldi temp,(ERROR_DCF_JAHR)
	STS(adr_DCF_ERROR_CODE),temp
	ret
DCF_ZEIT_JAHR_OK:
; --------------------------------------------------------------------------
	; DCF-ZEIT ist korrekt !!!		 
	cbi (LED_DCF_GRUEN_PORT),(LED_DCF_GRUEN_PIN_NR)	; DCF-GRUEN	
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 	; DCF-ROT	
	; PROGRAMMFREIGABE			
	STS(adr_FREIGABE_PROGRAMM),EINS
	; DCF_GUELTIG				
	STS(adr_DCF_GUELTIG),EINS
	; ERROR auf NULL			
	STS(adr_DCF_ERROR_CODE),NULL
	; SEKUNDEN auf NULL			
	STS(adr_ss_VT),NULL
	STS(adr_ss_100),NULL
	STS(adr_ss),NULL
	; MINUTEN					
	LDS temp,(adr_DCF_mm) 				; aus SRAM laden	
	STS (adr_mm),temp					; in SRAM speichern	
	; STUNDEN					
	LDS temp,(adr_DCF_hh) 				; aus SRAM laden	
	STS (adr_hh),temp					; in SRAM speichern	
	; TAG						
	LDS temp,(adr_DCF_TAG) 				; aus SRAM laden	
	STS (adr_TAG),temp					; in SRAM speichern	
	; Wochentag					
	LDS temp,(adr_DCF_WOCHENTAG) 		; aus SRAM laden	
	STS (adr_WOCHENTAG),temp			; in SRAM speichern	
	; MONAT						
	LDS temp,(adr_DCF_MONAT) 			; aus SRAM laden	
	STS (adr_MONAT),temp				; in SRAM speichern	
	; JAHR						
	LDS temp,(adr_DCF_JAHR) 			; aus SRAM laden	
	STS (adr_JAHR),temp					; in SRAM speichern	
	; MESZ						
	LDS temp,(adr_DCF_SOMMERZEIT) 		; aus SRAM laden	
	STS (adr_MESZ),temp			; in SRAM speichern	
ret
;######################################################################## 	
;########################################################################	
;######################################################################## 	
