; DCF77-1-WIRE									
; Bernhard.Erfurt@gmx.de						
; 08/2012										
;												

; LED GRUEN - DCF OK / 							
; LED GELB	- DCF Signal 						
; LED ROT 	- DCF heute noch nicht korrekt empfangen	

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> DISPLAY								
; PB1 ==> DISPLAY								
; PB2 ==> DISPLAY								
; PB3 ==> DISPLAY								
; PB4 ==> DISPLAY-RS							
; PB5 ==> DISPLAY-E								
; PB6 ==> Quarz	16MHz							
; PB7 ==> Quarz	16MHz							
;												
; PC0 ==> DCF-EINGANG							
; PC1 ==> LED GRN								
; PC2 ==> LED GELB								
; PC3 ==> LED ROT								
; PC4 ==> BEEP 									
; PC5 ==> RELAIS								
;												
; PD0 ==> TASTE (MENUE)							
; PD1 ==> TASTE (MENUE)							
; PD2 ==> 1-WIRE								
; PD3 ==> TASTE (MENUE)							
; PD4 ==> TASTE (MENUE)							
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT		=16000000			; 16 MHz	
; TIMER-WERTE									
.equ TIMERWERT0 =256-250			;(2 hoch 8  minus 250)		bei 16MHz + Vorteiler   64 => 0.001s =1ms	
; VERSION										
.equ VERSION_NR						= 8
.equ VERSION_TAG					= 21
.equ VERSION_MONAT					= 8
.equ VERSION_JAHR					= 12
.equ VERSION_WOCHENTAG				= 2			; 1=Mo		
.equ VERSION_MESZ					= 1
.equ VERSION_ss						=45
.equ VERSION_mm						=59
.equ VERSION_hh						=23
; DCF-TRIGGERGRNZE								
.equ DCF_TRIGGERGRENZE				= 3
; 1-WIRE-SONDERFUNKTIONEN						
.equ OW_BUS_RESET_ZULASSEN			= 0			; 1=SLAVE-RESET wenn BUS lnger LOW 	
; 1-WIRE-ROM-ID	(Prfsumme wird automatisch korrigiert)		
.equ ROM_ID_BYTE1					= 0xEF		; FAMILY xEF=PRIVAT x10=DS18s20 x27=DS2417(RTC)
.equ ROM_ID_BYTE2					= 0x00
.equ ROM_ID_BYTE3					= 0x70
.equ ROM_ID_BYTE4					= 0xF7
.equ ROM_ID_BYTE5					= 0xDC
.equ ROM_ID_BYTE6					= 0x00
.equ ROM_ID_BYTE7					= 0x00
.equ ROM_ID_BYTE8					= 0x00		; Prfsumme				
; 1-WIRE-BUS									
.equ OW_PIN_NR						= 2
.equ OW_PORT						= PORTD
.equ OW_DDR							= DDRD
.equ OW_PIN							= PIND
; 1-WIRE-ROM-COMMANDS							
.equ OW_COMMAND_READ_ROM			= 0x33		; READ-ROM				
.equ OW_COMMAND_MATCH_ROM			= 0x55		; MATCH-ROM				
.equ OW_COMMAND_SEARCH_ROM			= 0xF0		; SEARCH-ROM			
.equ OW_COMMAND_SKIP_ROM			= 0xCC		; SKIP-ROM				
; 1-WIRE-FUNCTION-COMMANDS						
.equ OW_FUNCTION_READ_SCRATCHPAD_A	=0xF0		; read  PRIVATE- DATA	
.equ OW_FUNCTION_WRITE_SCRATCHPAD_A	=0xF6		; write PRIVATE- DATA	
.equ OW_FUNCTION_READ_SCRATCHPAD_B	=0x66		; read  DS2417(RTC)		
.equ OW_FUNCTION_WRITE_SCRATCHPAD_B	=0x99		; write DS2417(RTC)		
.equ OW_FUNCTION_READ_SCRATCHPAD_C	=0xBE		; read  DS19s20			
.equ OW_FUNCTION_WRITE_SCRATCHPAD_C	=0x4E		; write DS19s20			
; 1-WIRE-FUNCTION-SONDER-COMMANDS 				
; (z.B. fr Start einer Messung)				
.equ OW_FUNCTION_SONDER_A			=0x44		;CONVERT "T" DS19s20	
.equ OW_FUNCTION_SONDER_B			=0x55		; DUMMY					
.equ OW_FUNCTION_SONDER_C			=0x66		; DUMMY					
; 1-WIRE-STATUS (nicht ndern!)					
.equ OW_STATUS_RX_BEREIT			=0x00		; Empfangsbereit								
.equ OW_STATUS_RX_0SLOT				=0xE0		; eine "0" wurde vom MASTER empfangen			
.equ OW_STATUS_RX_1SLOT				=0xE1		; eine "1" wurde vom MASTER empfangen			
.equ OW_STATUS_TX_0SLOT				=0xF0		; eine "0" muss zum MASTER gesendet werden		
.equ OW_STATUS_TX_1SLOT				=0xF1		; eine "1" muss zum MASTER gesendet werden		
.equ OW_STATUS_GESPERRT				=0xFF		; GESPERRT										
; 1-WIRE-LED (GRUEN)							
.equ LED_OW_GRUEN_PIN_NR			= 5
.equ LED_OW_GRUEN_DDR				= DDRD
.equ LED_OW_GRUEN_PORT				= PORTD
; 1-WIRE-LED (GELB)								
.equ LED_OW_GELB_PIN_NR				= 6
.equ LED_OW_GELB_DDR				= DDRD
.equ LED_OW_GELB_PORT				= PORTD
; 1-WIRE-LED (ROT)								
.equ LED_OW_ROT_PIN_NR				= 7
.equ LED_OW_ROT_DDR					= DDRD
.equ LED_OW_ROT_PORT				= PORTD
; DCF-PORT										
.equ DCF_PIN_NR		= 0
.equ DCF_DDR		= DDRC
.equ DCF_PORT		= PORTC
.equ DCF_PIN		= PINC
; DCF-ERROR-CODES								
.equ ERROR_DCF_IMPULSLAENGE				= 1
.equ ERROR_DCF_DATENFELD				= 2
.equ ERROR_DCF_MINUTENIMPULS			= 10
.equ ERROR_DCF_NO_ANFANGSBIT			= 12
.equ ERROR_DCF_NO_ZEITINFORMATIONSBIT	= 14
.equ ERROR_DCF_MESZ						= 14
.equ ERROR_DCF_PARITAET_MINUTE			= 100
.equ ERROR_DCF_PARITAET_STUNDE			= 110
.equ ERROR_DCF_PARITAET_DATUM			= 120
.equ ERROR_DCF_STUNDE					= 200
.equ ERROR_DCF_MINUTE					= 200
.equ ERROR_DCF_TAG						= 200
.equ ERROR_DCF_WOCHENTAG				= 200
.equ ERROR_DCF_MONAT					= 200
.equ ERROR_DCF_JAHR						= 200
; LED-DCF-GRUEN									
.equ LED_DCF_GRUEN_PIN_NR			= 1
.equ LED_DCF_GRUEN_DDR				= DDRC
.equ LED_DCF_GRUEN_PORT				= PORTC
; LED-DCF-GELB									
.equ LED_DCF_GELB_PIN_NR			= 2
.equ LED_DCF_GELB_DDR				= DDRC
.equ LED_DCF_GELB_PORT				= PORTC
; LED-DCF-ROT									
.equ LED_DCF_ROT_PIN_NR				= 3
.equ LED_DCF_ROT_DDR				= DDRC
.equ LED_DCF_ROT_PORT				= PORTC
; RELAIS										
.equ RELAIS_PIN_NR					= 5
.equ RELAIS_DDR						= DDRC
.equ RELAIS_PORT					= PORTC
; BEEP											
.equ BEEP_PIN_NR					= 4
.equ BEEP_DDR						= DDRC
.equ BEEP_PORT						= PORTC
; TASTE "MENUE-PLUS"							
.equ TASTE_MENUE_PLUS_PIN_NR		= 0
.equ TASTE_MENUE_PLUS_PIN			= PIND
.equ TASTE_MENUE_PLUS_DDR			= DDRD
.equ TASTE_MENUE_PLUS_PORT			= PORTD
; TASTE "MENUE-MINUS"							
.equ TASTE_MENUE_MINUS_PIN_NR		= 1
.equ TASTE_MENUE_MINUS_PIN			= PIND
.equ TASTE_MENUE_MINUS_DDR			= DDRD
.equ TASTE_MENUE_MINUS_PORT			= PORTD
; TASTE "PLUS"									
.equ TASTE_PLUS_PIN_NR				= 3
.equ TASTE_PLUS_PIN					= PIND
.equ TASTE_PLUS_DDR					= DDRD
.equ TASTE_PLUS_PORT				= PORTD
; TASTE "MINUS"									
.equ TASTE_MINUS_PIN_NR				= 4
.equ TASTE_MINUS_PIN				= PIND
.equ TASTE_MINUS_DDR				= DDRD
.equ TASTE_MINUS_PORT				= PORTD
; LCD (DATA)									
.equ LCD_DATA0_DDR			= DDRB
.equ LCD_DATA1_DDR			= DDRB
.equ LCD_DATA2_DDR			= DDRB
.equ LCD_DATA3_DDR			= DDRB
.equ LCD_DATA0_PORT			= PORTB
.equ LCD_DATA1_PORT			= PORTB
.equ LCD_DATA2_PORT			= PORTB
.equ LCD_DATA3_PORT			= PORTB
.equ LCD_DATA0				= 0
.equ LCD_DATA1				= 1
.equ LCD_DATA2				= 2
.equ LCD_DATA3				= 3
; LCD RS (Befehl/DATEN)							
.equ LCD_RS_DDR				= DDRB
.equ LCD_RS_PORT			= PORTB
.equ LCD_RS					= 4
; LCD_ENABLE									
.equ LCD_E_DDR				= DDRB
.equ LCD_E_PORT				= PORTB
.equ LCD_E					= 5
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					=0x0060			; 0x0060 START Adresse 		

.equ adr_FREIGABE_PROGRAMM		=0x0060+0		
.equ adr_MENUE					=0x0060+1
.equ adr_TASTE					=0x0060+2

.equ adr_BS_ss					=0x0060+40			; BETRIEBSSTUNDEN		
.equ adr_BS_mm					=0x0060+41
.equ adr_BS_hh					=0x0060+42
.equ adr_BS_TAG_L				=0x0060+43
.equ adr_BS_TAG_H				=0x0060+44

.equ adr_KALENDERTAG_L			=0x0060+50			; Kalendertage 01.01.=1	
.equ adr_KALENDERTAG_H			=0x0060+51


.equ adr_ss_VT					=0x0060+60			; Vorteiler	
.equ adr_ss_100					=0x0060+61			; 100-el	

.equ adr_ss						=0x0060+100			; Sekunden	
.equ adr_mm						=0x0060+101			; Minuten	
.equ adr_hh						=0x0060+102			; Stunden	
.equ adr_TAG					=0x0060+103			; Tag		
.equ adr_WOCHENTAG				=0x0060+104			; WochenTag	
.equ adr_MONAT					=0x0060+105			; Monat		
.equ adr_JAHR					=0x0060+106			; Jahr		
.equ adr_MESZ					=0x0060+107			; SOMMERZEIT 0/1
.equ adr_SONNE_AUFGANG_mm		=0x0060+108			; SONNENAUFGANG				
.equ adr_SONNE_AUFGANG_hh		=0x0060+109			; SONNENAUFGANG				
.equ adr_SONNE_UNTERGANG_mm		=0x0060+110			; SONNENUNTERGANG			
.equ adr_SONNE_UNTERGANG_hh		=0x0060+111			; SONNENUNTERGANG

.equ adr_DCF_mm					=0x0060+200			; Minuten 	aus DCF-Protokoll	
.equ adr_DCF_hh					=0x0060+201			; Stunden 	aus DCF-Protokoll	
.equ adr_DCF_TAG				=0x0060+202			; Tag	 	aus DCF-Protokoll	
.equ adr_DCF_WOCHENTAG			=0x0060+203			; WochenTag aus DCF-Protokoll	
.equ adr_DCF_MONAT				=0x0060+204			; Monat	 	aus DCF-Protokoll	
.equ adr_DCF_JAHR				=0x0060+205			; Jahr	 	 aus DCF-Protokoll	
.equ adr_DCF_SOMMERZEIT			=0x0060+206			; SOMMERZEIT aus DCF-Protokoll	


.equ adr_DCF_SAMPLES_ZEIGER		=0x0060+210
.equ adr_DCF_SAMPLES_A			=0x0060+211			;
.equ adr_DCF_SAMPLES_B			=0x0060+212			;
.equ adr_DCF_BIT				=0x0060+214			; DCF-BIT						

.equ adr_DCF_IMPULS_OLD			=0x0060+215
.equ adr_DCF_IMPULS_PHASE		=0x0060+216


.equ adr_DCF_ZEIGER				=0x0060+222			; Zeiger fr DCF-FELD			
.equ adr_DCF_GUELTIG			=0x0060+223			; DCF-Protokoll ist geprft und gltig			
.equ adr_DCF_ERROR_CODE			=0x0060+224			; DCF-ERROR-CODE				
.equ adr_DCF_ONLINE_mm			=0x0060+225			; ONLINE	
.equ adr_DCF_ONLINE_hh			=0x0060+226
.equ adr_DCF_ONLINE_TAG			=0x0060+227
.equ adr_DCF_ONLINE_MONAT		=0x0060+228
.equ adr_DCF_ONLINE_JAHR		=0x0060+229
.equ adr_DCF_OFFLINE_mm			=0x0060+230			; OFFLINE	
.equ adr_DCF_OFFLINE_hh			=0x0060+231
.equ adr_DCF_OFFLINE_TAG		=0x0060+232
.equ adr_DCF_OFFLINE_MONAT		=0x0060+233
.equ adr_DCF_OFFLINE_JAHR		=0x0060+234
.equ adr_DCF_BEREICH			=0x0060+235	 		; 60 BYTES fr DCF-FELD			



.equ adr_OW_STATUS					=0x0060+600		; OW-STATUS						
.equ adr_OW_ZAEHLER_RESET_PRESENCE_L=0x0060+602		; fr Wartungszwecke (ZAEHLERWERTE)	
.equ adr_OW_ZAEHLER_RESET_PRESENCE_H=0x0060+604		; 									
.equ adr_OW_BIT_STARTADRESSE_L		=0x0060+606		; SRAM-BIT-STARTADRESSE				
.equ adr_OW_BIT_STARTADRESSE_H		=0x0060+608		; 									
.equ adr_OW_BIT_NUMMER_L			=0x0060+610		; SRAM-BIT-NR						
.equ adr_OW_BIT_NUMMER_H			=0x0060+612		; 									
.equ adr_OW_ZEIGER					=0x0060+614		; ZEIGER							
.equ adr_OW_BIT_ZAEHLER				=0x0060+616		; BIT-ZHLER						
.equ adr_OW_RX_BYTE					=0x0060+618		; RX-Byte							
.equ adr_OW_ROM_SEARCH_ZAEHLER		=0x0060+620		; Zhler							
.equ adr_OW_ROM_SEARCH_A			=0x0060+622		; "BIT A" (SEARCH)					
.equ adr_OW_RX_ROM_COMMAND			=0x0060+624		; ROM COMMAND 						
.equ adr_OW_RX_ROM_COMMAND_FERTIG	=0x0060+626		; ROM COMMAND abgearbeitet			
.equ adr_OW_RX_FUNCTION_COMMAND		=0x0060+628		; FUNCTION COMMAND					
.equ adr_OW_RX_FUNCTION_COMMAND_FERTIG=0x0060+630	; FUNCTION COMMAND abgearbeitet		
.equ adr_OW_ROM_ID_BEREICH8			=0x0060+632		; 8 BYTE ROM-ID SLAVE				
.equ adr_OW_SCRATCHPAD_A_BEREICH	=0x0060+650		; SCRATCHPAD-A (100 BYTE)			
.equ adr_OW_SCRATCHPAD_B_BEREICH	=0x0060+750		; SCRATCHPAD-B (100 BYTE)			
.equ adr_OW_SCRATCHPAD_C_BEREICH	=0x0060+850		; SCRATCHPAD-C (100 BYTE)

.equ adr_SRAM_CHECK				= 0x0060+900


; REGISTER										

.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp ONE_WIRE_INTERRUPT	; IRQ0 Handler  
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR  	; Timer1 Overflow Handler           					
rjmp TIM0_OVF			;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR 	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 					
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	cbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 ; ROTDCF	
	rcall wait_100ms
	sbi (LED_DCF_ROT_PORT),(LED_DCF_ROT_PIN_NR)	 ; ROTDCF	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM CLEAR										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	
; PORT B initialisieren								
	ldi temp, 0b00000000	
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000
	out DDRD, temp			
; PORT D setzen										
	ldi temp, 0b00000000
	out PORTD, temp				
; LED_INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; Watchdog aktivieren (max. Zeit)					
	rcall Watchdog_aktivieren
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED_TEST											
	rcall LED_TEST
; TASTATUR_INITIALISIERUNG							
	rcall TASTATUR_INITIALISIERUNG
; DCF_INITIALISIERUNG								
	rcall DCF_INITIALISIERUNG
; TIMER0_INITIALISIERUNG							
	rcall TIMER0_INITIALISIERUNG
; TIMER aktivieren									
	rcall TIMER_AKTIVIEREN
; 1-WIRE_INITIALISIERUNG							
	rcall ONE_WIRE_INITIALISIERUNG
; 1-WIRE-EXTERNER_INTERUPT_INITIALISIEREN			
	rcall EXTERNER_INTERUPT_INITIALISIEREN
; 1-WIRE-EXTERNER_INTERRUPT_AKTIVIEREN				
	rcall EXTERNER_INTERRUPT_AKTIVIEREN
; Startwerte										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; ZEIT				
	ldi temp,23
	STS(adr_hh),temp
	ldi temp,59
	STS(adr_mm),temp
	ldi temp,45
	STS(adr_ss),temp
	; DATUM				
	ldi temp,1
	STS(adr_TAG),temp
	ldi temp,1
	STS(adr_MONAT),temp
	ldi temp,0
	STS(adr_JAHR),temp
	; WOCHENTAG			
	ldi temp,5
	STS(adr_WOCHENTAG),temp
	; MESZ				
	ldi temp,0
	STS(adr_MESZ),temp
	; SRAM-CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; BETRIEBSSTUNDEN	
	ldi temp,0
	STS(adr_BS_ss),temp			; in SRAM speichern		
	ldi temp,59
	STS(adr_BS_mm),temp			; in SRAM speichern		
	ldi temp,23
	STS(adr_BS_hh),temp			; in SRAM speichern		
	ldi temp,255
	STS(adr_BS_TAG_L),temp		; in SRAM speichern		
	ldi temp,255
	STS(adr_BS_TAG_H),temp		; in SRAM speichern		



; LCD_INITIALISIERUNG								
	rcall LCD_INITIALISIERUNG
; ANZEIGE_BEGRUESSUNG								
	rcall ANZEIGE_BEGRUESSUNG

	rcall BEEP_500
; interrupts freigeben								
	sei


; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	rcall ABFRAGE_TASTATUR
	LDS temp,(adr_FREIGABE_PROGRAMM)
	tst temp 
	breq LOOP
;-------------------------------------------------------------------------------
	STS(adr_FREIGABE_PROGRAMM),NULL
	rcall FUNKTION_BERECHNUNG_KALENDERTAG
	rcall FUNKTION_SONNENAUFGANG_UNTERGANG_BERECHNEN
	rcall MENUE
	rcall BERECHNUNG_DCF_ONLINE_OFFLINE
	rcall BERECHNUNG_RELAIS_KLICK
	rcall PROGRAMM_CHECK
	rcall TASTATUR_WAIT
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "DCF77_1WIRE_INTERRUPT.asm"		; 1-wire-INTERRUPTS				
.include "DCF77_1WIRE_ROM_COMMAND.asm"		; 1-wire ROM-COMMANDS			
.include "DCF77_1WIRE_FUNCTION_COMMAND.asm"	; 1-wire FUNKTION-COMMANDS

.include "DCF77_TIMER.asm"
.include "DCF77_SONSTIGES.asm"
.include "DCF77_DCF.asm"
.include "DCF77_LCD_ini.asm"
.include "DCF77_LCD.asm"
.include "DCF77_LCD_KURZ.asm"
.include "DCF77_16MHZwait.asm"
; ##############################################################################
; ##############################################################################
; ##############################################################################
TABELLE_SONNENAUFGANG:
; TABELLE_SONNENAUFGANG											
; 01.01. = 819= "08:19 "UHR (GMT+1)								
;    1   2   3   4   5   6   7   8   9   10  11  12  13  14  15  16  17  18  19  20  21  22  23  24  25  26  27  28  29  30  31		
.dw 819,819,818,818,818,817,817,816,816,815,815,814,813,813,812,811,810,809,808,807,806,805,804,803,802,800,759,758,756,755,754 ; 01
.dw 752,751,749,748,746,744,743,741,739,738,736,734,732,730,729,727,725,723,721,719,717,715,713,711,709,707,705,703				; 02
.dw 700,658,656,654,652,650,647,645,643,641,638,636,634,632,629,627,625,623,620,618,616,613,611,609,606,604,602,600,557,555,553 ; 03
.dw 550,548,546,544,541,539,537,535,532,530,528,526,523,521,519,517,515,513,511,509,506,504,502,500,458,456,454,453,451,449		; 04
.dw 447,445,443,441,440,438,436,435,433,431,430,428,427,425,424,422,421,420,418,417,416,415,414,412,411,410,409,409,408,407,406 ; 05
.dw 405,405,404,403,403,402,402,401,401,401,401,400,400,400,400,400,400,400,400,401,401,401,401,402,402,403,403,404,404,405		; 06
.dw 406,407,407,408,409,410,411,412,413,414,415,416,417,419,420,421,422,424,425,426,428,429,430,432,433,435,436,438,439,441,442 ; 07
.dw 444,445,447,449,450,452,453,455,457,458,500,501,503,505,506,508,510,511,513,514,516,518,519,521,523,524,526,528,529,531,532 ; 08
.dw 534,536,537,539,541,542,544,546,547,549,550,552,554,555,557,559,600,602,603,605,607,608,610,612,613,615,616,618,620,621		; 09
.dw 623,625,626,628,630,631,633,635,636,638,640,641,643,645,646,648,650,651,653,655,656,658,700,701,703,705,706,708,710,712,713 ; 10
.dw 715,717,718,720,722,723,725,726,728,730,731,733,735,736,738,739,741,742,744,745,747,748,750,751,752,754,755,756,758,759		; 11
.dw 800,801,802,803,804,806,807,808,808,809,810,811,812,813,813,814,815,815,816,816,817,817,817,818,818,818,818,818,818,818,818 ; 12

TABELLE_SONNENUNTERGANG:
; TABELLE_SONNENUNTERGANG										
; 01.01. = 1621= "16:21 "UHR (GMT+1)							
;     1    2    3    4    5    6    7    8    9    10   11   12   13   14   15   16   17   18   19   20   21   22   23   24   25   26   27   28   29   30   31		
.dw 1621,1622,1623,1624,1625,1626,1628,1629,1630,1632,1633,1634,1636,1637,1639,1640,1642,1643,1645,1646,1648,1649,1651,1652,1654,1656,1657,1659,1701,1702,1704  ; 01
.dw 1706,1708,1709,1711,1713,1714,1716,1718,1720,1721,1723,1725,1727,1728,1730,1732,1734,1736,1737,1739,1741,1743,1744,1746,1748,1749,1751,1753					; 02
.dw 1755,1756,1758,1800,1802,1803,1805,1807,1808,1810,1812,1814,1815,1817,1819,1820,1822,1824,1825,1827,1829,1831,1832,1834,1836,1837,1839,1841,1842,1844,1846	; 03
.dw 1847,1849,1851,1852,1854,1856,1857,1859,1901,1902,1904,1906,1908,1909,1911,1913,1914,1916,1918,1919,1921,1923,1924,1926,1928,1929,1931,1933,1934,1936		; 04
.dw 1938,1939,1941,1943,1944,1946,1947,1949,1950,1952,1954,1955,1957,1958,2000,2001,2003,2004,2005,2007,2008,2009,2011,2012,2013,2015,2016,2017,2018,2019,2020  ; 05
.dw 2021,2022,2023,2024,2025,2026,2027,2028,2028,2029,2030,2030,2031,2031,2032,2032,2033,2033,2033,2033,2034,2034,2034,2034,2034,2034,2033,2033,2033,2033		; 06
.dw 2032,2032,2032,2031,2031,2030,2029,2029,2028,2027,2026,2025,2025,2024,2023,2022,2020,2019,2018,2017,2016,2014,2013,2012,2010,2009,2007,2006,2004,2003,2001	; 07
.dw 1959,1958,1956,1954,1952,1951,1949,1947,1945,1943,1941,1939,1937,1935,1933,1931,1929,1927,1925,1923,1921,1918,1916,1914,1912,1910,1907,1905,1903,1901,1858	; 08
.dw 1856,1854,1852,1849,1847,1845,1842,1840,1838,1835,1833,1831,1828,1826,1823,1821,1819,1816,1814,1812,1809,1807,1805,1802,1800,1758,1755,1753,1751,1748		; 09
.dw 1746,1744,1741,1739,1737,1735,1732,1730,1728,1726,1724,1721,1719,1717,1715,1713,1711,1709,1707,1705,1703,1701,1659,1657,1655,1653,1652,1650,1648,1646,1645	; 10
.dw 1643,1641,1640,1638,1636,1635,1633,1632,1631,1629,1628,1626,1625,1624,1623,1622,1621,1619,1618,1617,1617,1616,1615,1614,1613,1613,1612,1611,1611,1610		; 11
.dw 1610,1609,1609,1609,1608,1608,1608,1608,1608,1608,1608,1608,1608,1608,1609,1609,1609,1610,1610,1611,1611,1612,1612,1613,1614,1615,1615,1616,1617,1618,1619	; 12



TEXT_BEGRUESSUNG_1:
.db "ATmega8 DCF77",0
TEXT_BEGRUESSUNG_2:
.db "18.08.2012 ",0
